/*
 * File         : BV_Member.h
 * Author       : Tomasz Stachowiak
 * Created      : Thu May 21 19:34:58 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#ifndef __BV_MEMBER_H
#define __BV_MEMBER_H

#include <stdlib.h>

#include <BVN/Message.h>
#include <BVN/SOCK_Stream.h>
#include <BVN/Reactor.h>

#include "BV_Msg_Header.h"
#include "BV_Message.h"
#include "BV.h"

typedef unsigned char uchar;

class BV_Member
{
 public:
 
  BV_Member();
  BV_Member(SOCK_Stream *stream, uchar id, char *name, int host);
  BV_Member(char *name, int host);
  BV_Member(BV_Member *mbr);
  void operator= (BV_Member &mbr);

  int connect(Reactor *reactor);
  void close();
  uchar get_id(void);
  void set_id(uchar id);
  void set_name(char *name);
  void get_name(char *name);
  int get_host(void);
  int get_string(char *str);
  int get_participant(Participant *part);
  SOCK_Stream *get_stream();
  void set_stream(SOCK_Stream *stream);
  void set_internal_id(int internal_id);
  int get_internal_id();

  int send_msg(BV_Message *msg);

  int display_on_;

 private:
  
  uchar id_;
  char name_[20];
  int host_;
  int internal_id_;

  SOCK_Stream *stream_;

};



#endif

